%
% script para un codigo preliminar de diferencias finitas
%

global data

if(exist('initia')==0),
    disp('Enter variable INITIA ')
    disp(' initia == 0 ---> if is a continuation of an older run  ')
    disp(' initia ~= 0 ---> if started from the beginning  ')
    initia = input(' Initia = ')
end

% grid points
Nx = 40; Ny = 40;
x1 = (0:Nx-1)'/(Nx-1);
x2 = (0:Ny-1)'/(Ny-1);
[xnod,icone] = qq3d([x1,0*x1],[0*x2,x2]);
[numnp,ndm]=size(xnod);

% parameters
dt = 0.01;
ntime = 20;
conductivity = 1;
rho = 1;
Cp = 1;
ttime = 0;
ndf = 1;
maxit = 5;
tol_newton = 1e-10;
scaling = 1;
nfreqplot = 1;

% external fields
numnp = size(xnod,1);
% nodal source term
source = ones(numnp,1);
source = 0*xnod.^3;

tol  = 1e-6;
[ifaceb,nodes_bou] = pfbou2d(xnod,icone,1);
fixa = zeros(numnp,2);
xmin = min(xnod); xmax = max(xnod);
nodes_lef = find(abs(xnod(:,1)-xmin(1))<tol);
nodes_rig = find(abs(xnod(:,1)-xmax(1))<tol);
nodes_bot = find(abs(xnod(:,2)-xmin(2))<tol);
nodes_top = find(abs(xnod(:,2)-xmax(2))<tol);
[slip_data] = get_normal(xnod,icone,nodes_bou,1);
normal_node(slip_data(:,1),1:ndm) = slip_data(:,2:ndm+1);

if 0
    nodes_fixed = rmdblist(m2v(nodes_bou));
    fixa(nodes_fixed,1)=1;
    fixa(nodes_fixed,2)=xnod(nodes_fixed,1).^2;
    fixa(nodes_fixed,2)=0;
elseif 0
    %    nodes_fixed = rmdblist([nodes_lef;nodes_rig;nodes_bot]);
    nodes_fixed = rmdblist([nodes_lef;nodes_rig]);
    fixa(nodes_fixed,1)=1;
    fixa([nodes_lef],2)=0;
    fixa([nodes_rig],2)=1;
    %    fixa([nodes_bot],2)=0;
    fixa([nodes_top],2)=1;
elseif 0
    nodes_fixed = rmdblist([nodes_lef]);
    fixa(nodes_lef,1)=1;
    fixa(nodes_lef,2)=0;
    fixa(nodes_rig,2)=1;
elseif 1
    nodes_fixed = rmdblist([nodes_lef]);
    fixa(nodes_bot,2)=-1;
    fixa(nodes_top,2)=1;    
    fixa(nodes_rig,2)=0;
    fixa(nodes_fixed,1)=1;
    fixa(nodes_fixed,2)=0;
end

% initial state
if initia
    state = 0*xnod(:,1);
    state(nodes_fixed,1) = fixa(nodes_fixed,2);
    R = zeros(numnp,1);
end

% handle data
data.param.dt = dt;
data.param.rho = rho;
data.param.Cp = Cp;
data.param.conductivity = conductivity;
data.param.ntime = ntime;
data.param.type_solver = 'implicit';
data.param.relax = 1;
data.param.ndf = ndf;
data.param.scaling = scaling;
data.param.nfreqplot = nfreqplot;

data.xnod = xnod;
data.fixa = fixa;
data.icone = icone;
data.Nx = Nx;
data.Ny = Ny;
data.nodes_bou = nodes_bou;
data.normal_node = normal_node;

data.source = source;
data.state = state;

data.pre_step = 1;

for itime=1:ntime
    check_conv = 1;
    iter = 1;
    data.state_old = data.state;
    while check_conv
        ttime = ttime+dt;
        % ensamblaje
        [K,R] = fdm_assemble();
        % resolucion
        [phi_new,R] = fdm_solver(data,K,R);
        % update solution
        data.state = phi_new;
        % convergence check
        disp([' time step = ' num2str(itime) ' t= ' num2str(ttime) ' | R | = ' num2str(norm(R))])
        check_conv = (norm(R)>tol_newton)&(iter<=maxit);
        iter = iter+1;
        %keyboard;pause
    end
    % plot
    fdm_plot(data,itime)
end

