% calculo de un mapeo y su inversa entre numero de nodo y par de indices
% (i,j) que lo posicionan en la grilla
for i=1:Nx,
    for j=1:Ny,
        Indx(i,j)=(j-1)*Nx+i;
        Indx_inv(Indx(i,j),1)=i;
        Indx_inv(Indx(i,j),2)=j;
    end;
end

% computation of divided differences to approximate the spatial derivatives
for jndx=2:Ny-1,
    
    indx = (2:Nx-1);
    dx_fwd(Indx(indx,jndx),1) = (xnod(Indx(indx+1,jndx),1)-xnod(Indx(indx,jndx),1));
    dx_bkw(Indx(indx,jndx),1) = (xnod(Indx(indx,jndx),1)-xnod(Indx(indx-1,jndx),1));
    dx_cen(Indx(indx,jndx),1) = (xnod(Indx(indx+1,jndx),1)-xnod(Indx(indx-1,jndx),1));

    dy_fwd(Indx(indx,jndx),1) = (xnod(Indx(indx,jndx+1),2)-xnod(Indx(indx,jndx),2));
    dy_bkw(Indx(indx,jndx),1) = (xnod(Indx(indx,jndx),2)-xnod(Indx(indx,jndx-1),2));
    dy_cen(Indx(indx,jndx),1) = (xnod(Indx(indx,jndx+1),2)-xnod(Indx(indx,jndx-1),2));

    dx_half(Indx(indx,jndx),1) = (0.5*(dx_fwd(Indx(indx,jndx),1)+dx_bkw(Indx(indx,jndx),1)));
    dy_half(Indx(indx,jndx),1) = (0.5*(dy_fwd(Indx(indx,jndx),1)+dy_bkw(Indx(indx,jndx),1)));

end

% computation of some derivatives for boundary nodes, using ghost nodes
% (ficticious)
indx = 1; jndx = (1:Ny);
dx_fwd(Indx(indx,jndx),1) = (xnod(Indx(indx+2,jndx),1)-xnod(Indx(indx+1,jndx),1));

indx = Nx; jndx = (1:Ny);
dx_bkw(Indx(indx,jndx),1) = (xnod(Indx(indx-1,jndx),1)-xnod(Indx(indx-2,jndx),1));

indx = (1:Nx); jndx = 1;
dy_fwd(Indx(indx,jndx),1) = (xnod(Indx(indx,jndx+1),2)-xnod(Indx(indx,jndx),2));

indx = (1:Nx); jndx = Ny;
dy_bkw(Indx(indx,jndx),1) = (xnod(Indx(indx,jndx),2)-xnod(Indx(indx,jndx-1),2));

% ASSEMBLE rowg and colg only at the first time step
rowg = []; colg = []; coeg = [];
 
% aporte a la matriz, K0: termino diagonal, KE: termina al este
% (izquierda), KW: al oeste (derecha), KN : al norte (arriba) , 
% KS : al sur (abajo)
indx = (2:Nx-1);
 
for jndx=2:Ny-1,

    K0(Indx(indx,jndx),1) = ((-1) ./ dx_fwd(Indx(indx,jndx),1) - ...
        1 ./ dx_bkw(Indx(indx,jndx),1))./ dx_half(Indx(indx,jndx),1);

    K0(Indx(indx,jndx),1) = K0(Indx(indx,jndx),1) +  ...
        ((-1) ./ dy_fwd(Indx(indx,jndx),1) - 1 ./ dy_bkw(Indx(indx,jndx),1))./ dy_half(Indx(indx,jndx),1);

    K0(Indx(indx,jndx),1) = K0(Indx(indx,jndx),1) - rho*Cp/Dt;
    
    KE(Indx(indx,jndx),1) = 1 ./ dx_fwd(Indx(indx,jndx),1) ./ dx_half(Indx(indx,jndx),1);
    KW(Indx(indx,jndx),1) = 1 ./ dx_bkw(Indx(indx,jndx),1) ./ dx_half(Indx(indx,jndx),1);

    KN(Indx(indx,jndx),1) = 1 ./ dy_fwd(Indx(indx,jndx),1) ./ dy_half(Indx(indx,jndx),1);
    KS(Indx(indx,jndx),1) = 1 ./ dy_bkw(Indx(indx,jndx),1) ./ dy_half(Indx(indx,jndx),1);

    rows = Indx(indx,jndx); cols = rows; coef = K0(Indx(indx,jndx),1);
    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

    rows = Indx(indx,jndx); cols = Indx(indx-1,jndx); coef = KW(Indx(indx,jndx),1);
    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

    rows = Indx(indx,jndx); cols = Indx(indx+1,jndx); coef = KE(Indx(indx,jndx),1);
    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

    rows = Indx(indx,jndx); cols = Indx(indx,jndx+1); coef = KN(Indx(indx,jndx),1);
    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

    rows = Indx(indx,jndx); cols = Indx(indx,jndx-1); coef = KS(Indx(indx,jndx),1);
    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

end

% fixations
% fixed or Dirichlet
nodes_fixed = find(fixa(:,1)==1);
rows = nodes_fixed; cols = rows; coef = ones(length(nodes_fixed),1);
rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

% free or Neumann (ver fdm_assemble_2D ya que es similar)
nodes = rmdblist(m2v(nodes_bou));
nodes_Neuman = find(fixa(nodes,1)==0);
if isempty(nodes_Neuman)==0
    nodes_Neuman = rmdblist(nodes(nodes_Neuman));
end
ijv = [1,0;0,1];
if isempty(nodes_Neuman)==0
    no = normal_node(nodes_Neuman,:);
    for kn=1:length(nodes_Neuman)
        for kdm=1:ndm
            ii = ijv(kdm,1);jj = ijv(kdm,2);
            if abs(no(kn,kdm))>tol
                nn = kn;
                nodes = nodes_Neuman(kn);
                II = Indx_inv(nodes,1);
                JJ = Indx_inv(nodes,2);
                if II==1

                    K0 = -no(nn,1) ./(2*dx_fwd(nodes,1));
                    Kd =  no(nn,1) ./(2*dx_fwd(nodes,1));

                    rows = nodes; cols = rows; coef = K0;
                    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];
                    rows = nodes; cols = rows+2; coef = Kd;
                    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

                elseif II==Nx

                    K0 =  no(nn,1) ./(2*dx_bkw(nodes,1));
                    Ku = -no(nn,1) ./(2*dx_bkw(nodes,1));

                    rows = nodes; cols = rows; coef = K0;
                    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];
                    rows = nodes; cols = Indx(II-2,JJ); coef = Ku;
                    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

                elseif JJ==1

                    K0 = -no(nn,2) ./(2*dy_fwd(nodes,1));
                    Kd =  no(nn,2) ./(2*dy_fwd(nodes,1));

                    rows = nodes; cols = rows; coef = K0;
                    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];
                    rows = nodes; cols = Indx(II,JJ+2); coef = Kd;
                    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

                elseif JJ==Ny

                    K0 =   no(nn,2) ./(2*dy_bkw(nodes,1));
                    Ku =  -no(nn,2) ./(2*dy_bkw(nodes,1));

                    rows = nodes; cols = rows; coef = K0;
                    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];
                    rows = nodes; cols = Indx(II,JJ-2); coef = Ku;
                    rowg = [rowg;rows]; colg = [colg;cols]; coeg = [coeg;coef];

                end
            end
        end
    end
end

data.Indx = Indx;
data.Indx_inv = Indx_inv;
data.dx_fwd = dx_fwd;
data.dy_fwd = dy_fwd;
data.dx_bkw = dx_bkw;
data.dy_bkw = dy_bkw;
data.dx_half = dx_half;
data.dy_half = dy_half;
data.dx_cen = dx_cen;
data.dy_cen = dy_cen;

data.rowg = rowg;
data.colg = colg;
data.coeg = coeg;
